import org.junit.Assert;
import org.junit.Test;

public class MyMapTest {

    MyMap map = new MyMap();
    MyMap map2 = new MyMap();



    @Test
    public void addTest(){
        map.add("keystring", 4);
        map.add("another", 6);
        int actual = map.size();
        int expected = 2;
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void clearTest(){
        map.add("keystring", 4);
        map.add("another", 6);
        map.clear();
        int actual = map.size();
        int expected = 0;
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void containsKeyTrueTest(){
        map.add(3,4);
        map.add(7,5);
        boolean actual = map.containsKey(7);
        Assert.assertTrue(actual);
    }

    @Test
    public void containsKeyFalseTest(){
        map.add(3,4);
        map.add(7,5);
        boolean actual = map.containsKey(5);
        Assert.assertFalse(actual);
    }

    @Test
    public void containsValueTrueTest(){
        map.add(3,4);
        map.add(7,5);
        boolean actual = map.containsValue(4);
        Assert.assertTrue(actual);
    }
    @Test
    public void containsValueFalseTest(){
        map.add(3,4);
        map.add(7,5);
        boolean actual = map.containsValue(7);
        Assert.assertFalse(actual);
    }

    @Test
    public void entrySetTest(){
        map.add(3,4);
        map.add(7,5);
        map.add(5,6);
        Object [][] actual = map.entrySet();
        Object [][] expected = {{3,4}, {7,5}, {5,6}};
        Assert.assertArrayEquals(expected, actual);
    }

    @Test
    public void equalsTrueTest(){
        map.add(3,4);
        map.add(7,5);
        map2.add(3,4);
        map2.add(7,5);
        boolean actual = map.equals(map2);
        Assert.assertTrue(actual);
    }

    @Test
    public void equalsFalseTest(){
        map.add(3,4);
        map.add(7,5);
        map2.add(9,4);
        map2.add(7,5);
        boolean actual = map.equals(map2);
        Assert.assertFalse(actual);
    }

    @Test
    public void getTest(){
        map.add(3,4);
        map.add(7,5);
        map.add(5,6);
        Object actual = map.get(7);
        Object expected = 5;
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void getOrDefaultTest(){
        map.add(3,4);
        map.add(7,5);
        map.add(5,6);
        Object actual = map.getOrDefault(9, "default");
        Object expected = "default";
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void isEmptyTrueTest(){
        boolean actual = map.isEmpty();
        Assert.assertTrue(actual);
    }

    @Test
    public void isEmptyFalseTest(){
        map.add(3,4);
        boolean actual = map.isEmpty();
        Assert.assertFalse(actual);
    }

    @Test
    public void removeTest(){
        map.add(3,4);
        map.add(7,5);
        map.add(5,6);
        map.remove(7);
        int actual = map.size();
        int expected = 2;
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void replaceTest(){
        map.add(3,4);
        map.add(7,5);
        map.add(5,6);
        map.replace(3,9);
        Object actual = map. get(3);
        Object expected = 9;
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void valueSetTest(){
        map.add(3,4);
        map.add(7,5);
        map.add(5,6);
        Object[] actual = map.valueSet();
        Object[] expected = {3,7,5};
        Assert.assertArrayEquals(expected, actual);
    }

}
